TrieField (Solr 3.6.2 API)
Keywords: org.apache.solr.schema.TrieField class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.schema
Class TrieField

    java.lang.Object
      org.apache.solr.schema.FieldProperties
          org.apache.solr.schema.FieldType
              org.apache.solr.schema.PrimitiveFieldType
                  org.apache.solr.schema.TrieField

Direct Known Subclasses:
  TrieDoubleField, TrieFloatField, TrieIntField, TrieLongField

    public class TrieField

extends PrimitiveFieldType

Provides field types to support for Lucene's `NumericField`. See `NumericRangeQuery` for more details. It supports integer, float, long, double and date types.

For each number being added to this field, multiple terms are generated as per the algorithm described in the above link. The possible number of terms increases dramatically with lower precision steps. For the fast range search to work, trie fields must be indexed.

Trie fields are sortable in numerical order and can be used in function queries.

Note that if you use a precisionStep of 32 for int/float and 64 for long/double/date, then multiple terms will not be generated, range search will be no faster than any other number field, but sorting will still be possible.

Since:
  solr 1.4
Version:
  $Id: TrieField.java 1298427 2012-03-08 15:22:27Z janhoy $
See Also:
  `NumericRangeQuery`

Nested Class Summary
`static class` | `TrieField.TrieTypes`

Nested classes/interfaces inherited from class org.apache.solr.schema.FieldType
`FieldType.DefaultAnalyzer`

Field Summary
`static int` | `DEFAULT_PRECISION_STEP`
`protected Object` | `missingValue`
`protected int` | `precisionStep`
`protected int` | `precisionStepArg`
`protected TrieField.TrieTypes` | `type`

Fields inherited from class org.apache.solr.schema.FieldType
`analyzer, args, falseProperties, log, POLY_FIELD_SEPARATOR, queryAnalyzer, trueProperties, typeName`

Fields inherited from class org.apache.solr.schema.FieldProperties
`BINARY, INDEXED, MULTIVALUED, OMIT_NORMS, OMIT_POSITIONS, OMIT_TF_POSITIONS, REQUIRED, SORT_MISSING_FIRST, SORT_MISSING_LAST, STORE_TERMOFFSETS, STORE_TERMPOSITIONS, STORE_TERMVECTORS, STORED, TOKENIZED`

Constructor Summary
`TrieField()`

Method Summary
`Fieldable` | `createField(SchemaField field, String externalVal, float boost)` Used for adding a document when a field needs to be created from a type and a string.
`static String` | `getMainValuePrefix(FieldType ft)` expert internal use, subject to change.
`int` | `getPrecisionStep()`
`Query` | `getRangeQuery(QParser parser, SchemaField field, String min, String max, boolean minInclusive, boolean maxInclusive)` Returns a Query instance for doing range searches on this field type.
`SortField` | `getSortField(SchemaField field, boolean top)` Returns the SortField instance that should be used to sort fields of this type.
`TrieField.TrieTypes` | `getType()`
`ValueSource` | `getValueSource(SchemaField field, QParser qparser)` called to get the default value source (normally, from the Lucene FieldCache.)
`String` | `indexedToReadable(String indexedForm)` Given an indexed term, return the human readable representation
`protected void` | `init(IndexSchema schema, Map<String,String> args)` subclasses should initialize themselves with the args provided and remove valid arguments.
`boolean` | `isTokenized()` Returns true if fields of this type should be tokenized
`boolean` | `multiValuedFieldCache()` Returns true if a single field value of this type has multiple logical values for the purposes of faceting, sorting, etc.
`String` | `readableToIndexed(String val)` Given the readable value, return the term value that will match it.
`String` | `storedToIndexed(Fieldable f)` Given the stored field, return the indexed form
`String` | `storedToReadable(Fieldable f)` Given the stored field, return the human readable representation
`String` | `toExternal(Fieldable f)` Convert the stored-field format to an external (string, human readable) value
`String` | `toInternal(String val)` Convert an external value (from XML update command or from query string) into the internal format for both storing and indexing (which can be modified by any analyzers).
`Object` | `toObject(Fieldable f)` Convert the stored-field format to an external object.
`void` | `write(TextResponseWriter writer, String name, Fieldable f)` calls back to TextResponseWriter to write the field value
`void` | `write(XMLWriter xmlWriter, String name, Fieldable f)` Renders the specified field as XML

Methods inherited from class org.apache.solr.schema.FieldType
`createField, createFields, getAnalyzer, getArg, getFieldIndex, getFieldQuery, getFieldStore, getFieldTermVec, getIndexOptions, getQueryAnalyzer, getStringSort, getTypeName, getValueSource, hasProperty, isMultiValued, isPolyField, restrictProps, setAnalyzer, setQueryAnalyzer, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### DEFAULT_PRECISION_STEP

    public static final int DEFAULT_PRECISION_STEP

See Also:
  Constant Field Values

### precisionStepArg

    protected int precisionStepArg

### precisionStep

    protected int precisionStep

### type

    protected TrieField.TrieTypes type

### missingValue

    protected Object missingValue

Constructor Detail

### TrieField

    public TrieField()

Method Detail

### init

    protected void init(IndexSchema schema,
                        Map<String,String> args)

  Description copied from class: `FieldType`
  subclasses should initialize themselves with the args provided and remove valid arguments. leftover arguments will cause an exception. Common boolean properties have already been handled.

  Overrides:
    `init` in class `PrimitiveFieldType`

### toObject

    public Object toObject(Fieldable f)

  Description copied from class: `FieldType`
  Convert the stored-field format to an external object.

  Overrides:
    `toObject` in class `FieldType`
  See Also:
    `FieldType.toInternal(java.lang.String)`

### getSortField

    public SortField getSortField(SchemaField field,
                                  boolean top)

  Description copied from class: `FieldType`
  Returns the SortField instance that should be used to sort fields of this type.

  Specified by:
    `getSortField` in class `FieldType`
  See Also:
    `SchemaField.checkSortability()`

### getValueSource

    public ValueSource getValueSource(SchemaField field,
                                      QParser qparser)

  Description copied from class: `FieldType`
  called to get the default value source (normally, from the Lucene FieldCache.)

  Overrides:
    `getValueSource` in class `FieldType`

### write

    public void write(XMLWriter xmlWriter,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  Renders the specified field as XML

  Specified by:
    `write` in class `FieldType`
  Throws:
    `IOException`

### write

    public void write(TextResponseWriter writer,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  calls back to TextResponseWriter to write the field value

  Specified by:
    `write` in class `FieldType`
  Throws:
    `IOException`

### isTokenized

    public boolean isTokenized()

  Description copied from class: `FieldType`
  Returns true if fields of this type should be tokenized

  Overrides:
    `isTokenized` in class `FieldType`

### multiValuedFieldCache

    public boolean multiValuedFieldCache()

  Description copied from class: `FieldType`
  Returns true if a single field value of this type has multiple logical values for the purposes of faceting, sorting, etc. Text fields normally return true since each token/word is a logical value.

  Overrides:
    `multiValuedFieldCache` in class `FieldType`

### getPrecisionStep

    public int getPrecisionStep()

  Returns:
    the precisionStep used to index values into the field

### getType

    public TrieField.TrieTypes getType()

  Returns:
    the type of this field

### getRangeQuery

    public Query getRangeQuery(QParser parser,
                               SchemaField field,
                               String min,
                               String max,
                               boolean minInclusive,
                               boolean maxInclusive)

  Description copied from class: `FieldType`
  Returns a Query instance for doing range searches on this field type. `SolrQueryParser` currently passes part1 and part2 as null if they are '*' respectively. minInclusive and maxInclusive are both true currently by SolrQueryParser but that may change in the future. Also, other QueryParser implementations may have different semantics.

  Sub-classes should override this method to provide their own range query implementation. They should strive to handle nulls in part1 and/or part2 as well as unequal minInclusive and maxInclusive parameters gracefully.

  Overrides:
    `getRangeQuery` in class `FieldType`
    `field` - the schema field
    `min` - the lower boundary of the range, nulls are allowed.
    `max` - the upper boundary of the range, nulls are allowed
    `minInclusive` - whether the minimum of the range is inclusive or not
    `maxInclusive` - whether the maximum of the range is inclusive or not
  Returns:
    a Query instance to perform range search according to given parameters
  See Also:
    `SolrQueryParser.getRangeQuery(String, String, String, boolean)`

### storedToReadable

    public String storedToReadable(Fieldable f)

  Description copied from class: `FieldType`
  Given the stored field, return the human readable representation

  Overrides:
    `storedToReadable` in class `FieldType`

### readableToIndexed

    public String readableToIndexed(String val)

  Description copied from class: `FieldType`
  Given the readable value, return the term value that will match it.

  Overrides:
    `readableToIndexed` in class `FieldType`

### toInternal

    public String toInternal(String val)

  Description copied from class: `FieldType`
  Convert an external value (from XML update command or from query string) into the internal format for both storing and indexing (which can be modified by any analyzers).

  Overrides:
    `toInternal` in class `FieldType`
  See Also:
    `FieldType.toExternal(org.apache.lucene.document.Fieldable)`

### toExternal

    public String toExternal(Fieldable f)

  Description copied from class: `FieldType`
  Convert the stored-field format to an external (string, human readable) value

  Overrides:
    `toExternal` in class `FieldType`
  See Also:
    `FieldType.toInternal(java.lang.String)`

### indexedToReadable

    public String indexedToReadable(String indexedForm)

  Description copied from class: `FieldType`
  Given an indexed term, return the human readable representation

  Overrides:
    `indexedToReadable` in class `FieldType`

### storedToIndexed

    public String storedToIndexed(Fieldable f)

  Description copied from class: `FieldType`
  Given the stored field, return the indexed form

  Overrides:
    `storedToIndexed` in class `FieldType`

### createField

    public Fieldable createField(SchemaField field,
                                 String externalVal,
                                 float boost)

  Description copied from class: `FieldType`
  Used for adding a document when a field needs to be created from a type and a string.

  By default, the indexed value is the same as the stored value (taken from toInternal()). Having a different representation for external, internal, and indexed would present quite a few problems given the current Lucene architecture. An analyzer for adding docs would need to translate internal->indexed while an analyzer for querying would need to translate external->indexed.

  The only other alternative to having internal==indexed would be to have internal==external. In this case, toInternal should convert to the indexed representation, toExternal() should do nothing, and createField() should *not* call toInternal, but use the external value and set tokenized=true to get Lucene to convert to the internal(indexed) form.

  :TODO: clean up and clarify this explanation.

  Overrides:
    `createField` in class `FieldType`
  See Also:
    `FieldType.toInternal(java.lang.String)`

### getMainValuePrefix

    public static String getMainValuePrefix(FieldType ft)

  expert internal use, subject to change. Returns null if no prefix or prefix not needed, or the prefix of the main value of a trie field that indexes multiple precisions per value.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD